VERS	EQU	'2 '	; January 3, 1983 5:41 klf "PUTSASI.ASM"
;
	TITLE	'PUTSASI - SASI system generation program'

		MACLIB	Z80
		$-MACRO
;----------------------------------------------------------
;
;	PORTS AND CONSTANTS
;
GPIO	EQU	0F2H		; SWITCH 501

ACK	EQU	00000001B
INT	EQU	00000010B
PER	EQU	00000100B
BUSY	EQU	00001000B
CMND	EQU	00010000B
MSG	EQU	00100000B
POUT	EQU	01000000B
REQ	EQU	10000000B

RUN	EQU	00000000B
SWRS	EQU	00010000B
INTE	EQU	00100000B
SEL	EQU	01000000B

RDBL	EQU	8	; COMMAND OP CODES
WRBL	EQU	10
INIT	EQU	12

WRALL	EQU	0	; WRITE TO ALLOCATED
WRDIR	EQU	1	; WRITE TO DIRECTORY
WRUNA	EQU	2	; WRITE TO UNALLOCATED
READOP	EQU	3	; READ OPERATION
;
;	MISCELLANEOUS DATA VALUES
;
;	MAGIC SECTOR
;
DPHDPB	EQU	10
DPHL	EQU	16		; LENGTH OF DPH
DPBL	EQU	21		; LENGTH OF DPB + MODE BYTES
DCTYPE	EQU	3   ;	1 byte	; OFFSET TO DRIVE/CONTROLLER TYPE BYTE
CSTRNG	EQU	13  ;	6 bytes ; OFFSET TO COMMAND STRING
NPART	EQU	19  ;	1 byte	; OFFSET TO NUMBER OF PARTITIONS
CBYTE	EQU	4   ;	1 byte	; OFFSET TO CONTROL BYTE
DDATA	EQU	5   ;	8 bytes ; OFFSET TO CMD STRING FOR XEBEC ONLY
SECTBL	EQU	20  ;  27 bytes ; OFFSET TO PARTITION TABLE
DDPB	EQU	47  ; 189 bytes ; OFFSET TO DPB's
;
BS	EQU	08H		; BACK-SPACE
CR	EQU	0DH		; CARRIAGE RETURN
LF	EQU	0AH		; LINE FEED
ESC	EQU	1BH		; ESCAPE
BEL	EQU	07H		; BELL
CTLC	EQU	03H		; CONTROL-C

PAGE


;	SYSTEM INFORMATION
;
FCB	EQU	005CH		; DEFAULT FCB LOCATION
FCBCR	EQU	FCB+32		; CURRENT RECORD LOCATION
TPA	EQU	0100H		; TRANSIENT PROGRAM AREA
BDOS	EQU	5H		; DOS ENTRY POINT
CPM	EQU	0		; WARM BOOT LOCATION
WBOOT	EQU	1		; ADDRESS OF WARM BOOT
TBOFF	EQU	71H		; OFFSET TO LOCATION OF 'NEWDSK' IN BIOS
DRIVO	EQU	4AH		; OFFSET TO DRIVE O: IN LOG/PHY TABLE
DBASE	EQU	4CH		; OFFSET TO DRIVE BASE TABLE
;
;	SYSGEN INFORMATION
;
LOADP	EQU	900H		; LOAD POINT FOR SYSTEM DURING LOAD/STORE
LOADS	EQU	100H		; SIZE OF BOOT ROUTINE
SYSIOA	EQU	LOADP+LOADS	; CCP FILE LOAD ADDRESS
SYSIOS	EQU	16		; RECORDS IN CCP FILE
;
;	BDOS FUNCTION CALLS
;
CONI	EQU	1		; CONSOLE INPUT FUNCTION
PRINT	EQU	9		; PRINT TEXT STRING FUNCTION
OPENF	EQU	15		; DISK OPEN FUNCTION
DREADF	EQU	20		; DISK READ FUNCTION
QUSER	EQU	32		; QUERY/SET USER NUMBER
SETDM	EQU	26
WRITEF	EQU	21
CLOSEF	EQU	16
DELT	EQU	19
CREAT	EQU	22
SETDMA	EQU	26
REST	EQU	37		; RESET INDIVIDUAL DRIVES
;
;	BIOS ENTRY POINTS (COMPUTED RELATIVE TO WBOOT)
;
SELDSK	EQU	24		; WBOOT+24 FOR DISK SELECT
SETTRK	EQU	27		; WBOOT+27 FOR SET TRACK FUNCTION
SETSEC	EQU	30		; WBOOT+30 FOR SET SECTOR FUNCTION
WRITF	EQU	39		; WBOOT+39 FOR WRITE FUNCTION

PAGE


	ORG	TPA		; TRANSIENT PROGRAM AREA

HSTBUF: 		; USE INIT CODE AREA FOR BUFFER LATER
CSV0:
ALV0	EQU	HSTBUF+512


START:
	LXI	SP,STACK	; SET LOCAL STACK POINTER
	LXI	D,SIGNON
	CALL	OUTMSG

; SAVE THESE BIOS ADDRESSES FOR FUTURE USE
	LHLD	WBOOT		; ADDRESS OF BIOS
	LXI	D,TBOFF-3	; OFFSET TO DRIVE INFO TABLE
	DAD	D
	SHLD	NEWDSK		; REQUESTED DISK
	INX	H
	INX	H
	SHLD	NEWSEC		; REQUESTED SECTOR
	INX	H
	SHLD	HRDTRK		; REQUESTED TRACK
	INX	H
	INX	H
	SHLD	DMAA		; DMA ADDRESS
;
	LDA	FCB+1		; CHECK FOR DEFAULT FILE LOAD INSTEAD OF GET
	CPI	' '		; BLANK IF NO FILE SPECIFIED
	JRZ	ASKRUN		; SKIP TO 'HAVE YOU RUN MOVCPM' MESSAGE
PAGE


	LXI	H,FCB		; FIRST BUILD NAME IN TEXT STRING
	LXI	D,SNAME 	; FOR OUTPUT TO THE USER
	MOV	A,M		; drive designator
	INX	H
	ORA	A
	JRNZ	SN0
	STAX	D
	INX	D
	STAX	D
	JR	SN1
SN0:	ORI	'A'
	STAX	D
	INX	D		; point to ":"
SN1:	INX	D		; point to first letter of name
	MVI	C,8		; 8 characters in name
NL0:	MOV	A,M
	INX	H
	CPI	' '
	JRNZ	SN2
	XRA	A
SN2:	STAX	D
	INX	D
	DCR	C
	JRNZ	NL0
	LXI	H,SNAME+11	; MOVE "COM" FROM TEXT STRING TO FCB
	LXI	D,FCB+9
	LXI	B,3
	LDIR

	LXI	D,GETF
	CALL	OUTMSG
	LXI	D,FCB		; TRY TO OPEN IT
	MVI	C,OPENF
	CALL	BDOS
	INR	A		; 255 BECOMES 00
	LXI	D,NOFILE	; ERROR: file not on disk
	JZ	MSGSBT		; DO NOT RESTORE DRIVE O:
PAGE


;	FILE PRESENT, READ TO LOAD POINT
;
	XRA	A
	STA	FCBCR		; CURRENT RECORD = 0
	MVI	C,(LOADP-TPA)/128 ; NUMBER OF SECTORS TO READ BEFORE
PRERD:				; THE BEGINNING OF THE BOOT MODULE
	PUSH	B		; SAVE COUNT
	LXI	D,FCB		; INPUT FILE CONTROL COUNT
	MVI	C,DREADF
	CALL	BDOS		; ASSUME SET TO DEFAULT BUFFER
	POP	B		; RESTORE COUNT
	ORA	A
	LXI	D,BADFIL
	JNZ	MSGSBT		; CANNOT ENCOUNTER END-OF FILE
	DCR	C		; COUNT DOWN
	JRNZ	PRERD		; FOR ANOTHER SECTOR
	LXI	H,LOADP 	; ADDRESS FOR SYSTEM LOAD
RDINP:
	PUSH	H		; LOAD THE SYSTEM IMAGE
	CALL	SDMA		; DMA ADDRESS SET
	LXI	D,FCB		; READY FOR READ
	MVI	C,DREADF
	CALL	BDOS		; 
	POP	H		; RECALL DMA ADDRESS
	ORA	A		; 00 IF READ OK
	JRNZ	PUTSYS		; ASSUME EOF IF NOT.
	LXI	D,128
	DAD	D		; HL IS NEW LOAD ADDRESS
	JR	RDINP

ASKRUN:
	LXI	D,ASKGET	; DID YOU RUN 'MOVCPM'
ASKAGN: CALL	MESSA1
	CALL	GETCHAR
	CPI	CR		; CR ASSUMES 'Y'
	JRZ	PUTSYS		; SKIP IF CR ONLY
	CPI	'Y'
	JRZ	PUTSYS
	CPI	'N'
	LXI	D,NOACTN
	JZ	MSGSBT
	LXI	D,BELMSG
	JR	ASKAGN		; TO TRY AGAIN
PAGE


;	WRITE SYSTEM (EXCEPT CCP.SYS) TO SYSTEM TRACKS
;
PUTSYS:
	LXI	D,CONMSG	; GET CONTROLLER NUMBER FROM USER
ASKCON: CALL	MESSGET
	JRZ	DFLT0
	LXI	D,BELMSG
	CPI	'0'
	JRC	ASKCON
	CPI	'8'
	JRNC	ASKCON
	SUI	'0'
	STA	CNUM
DFLT0:	LXI	D,LUNMSG	; GET LOGICAL UNIT NUMBER FROM USER
ASKLUN: CALL	MESSGET
	JRZ	DFLT00
	LXI	D,BELMSG
	CPI	'0'
	JRC	ASKLUN
	CPI	'4'
	JRNC	ASKLUN
	SUI	'0'
	RRC
	RRC
	RRC
	STA	LUN
DFLT00: LXI	D,4000H 	; DRIVE O:
	MVI	C,REST		; RESET DRIVE
	CALL	BDOS
	LHLD	WBOOT		; ADDRESS OF BIOS
	LXI	D,DRIVO-3	; OFFSET TO DRIVE O:
	DAD	D
	MOV	A,M
	STA	OLDLET		; SAVE EXISTING DRIVE NUMBER
	MVI	M,50		; AND INSTALL NEW DRIVE (SASI)
	INX	H		; GET ADDRESS OF DRIVE BASE TABLE
	INX	H		; TO FIND AN EMPTY HOLE
	MVI	B,8
NXONE:	MOV	A,M		; LOW DRIVE NUMBER
	CPI	50		; IS IT SASI DRIVER ?
	JRNZ	NOSASI
	MVI	M,255		; DISABLE CURRENT SASI DRIVER
	SHLD	SASILOC
NOSASI: INX	H
	CMP	M		; ARE THEY THE SAME
	JRZ	GOTLOC
	INX	H		; POINT TO ADDRESS
	INX	H
	INX	H		; SKIP ADDRESS
	DJNZ	NXONE
	LXI	D,NORMSG
	JMP	TWOMSG
GOTLOC: DCX	H		; POINT TO LOW DRIVE NUMBER
	SHLD	DRVLOC		; FOR CLEARING LATER
	MVI	M,50
	INX	H
	MVI	M,51
	INX	H
	MVI	M,0
	INX	H
	MVI	M,8		; INSTALL DRIVER ADDRESS
	MVI	A,14		; DRIVE O: FOR SELECT
	JMP	CONTIN		; JUMP TO END OF DATA BUFFER

MESSGET:CALL	MESSA1
	CALL	GETCHAR
	CPI	CR
	RET

PAGE



;	DRIVER INITIALIZATION CODE
;
INIT$SASI:
	MVI	B,7CH
	IN	GPIO		; READ SWITCH 501
	ANI	00000011B	; WHAT'S PORT 7C SET FOR ?
	CPI	00000010B	;  IF Z67, THEN THIS IS IT
	JRZ	GOTPRT
	MVI	B,78H
	IN	GPIO		; READ SWITCH 501
	ANI	00001100B	; WHAT'S PORT 78 SET FOR ?
	CPI	00001000B	;  IF Z67, THEN THIS IS IT
	RNZ
GOTPRT: MOV	A,B
	STA	BASE$PORT	; SAVE BASE PORT ADDRESS
	MVI	A,RDBL		; OP CODE TO READ A SECTOR
	STA	CMCDE
	LDA	LUN		; LOGICAL UNIT NUMBER
	STA	CMBFR+1
	XRA	A		; SECTOR 0
	STA	CMBFR+2
	STA	CMBFR+3
	INR	A
	STA	CMBFR+4 	; READ 1 SECTOR
	JMP	CHK$INIT
PAGE


;	MISCELLANEOUS ROUTINES
;
;
;	GET ONE CHARACTER USER RESPONSE IN 'A'
;
GETCHAR:MVI	C,CONI		; GET A CHARACTER RESPONSE FROM
	CALL	BDOS		; THE USER AND MAKE UPPER CASE
	CPI	CTLC		; REBOOT ON CONTROL-C
	JZ	SAFEBT
	CPI	'a' ! RC	; RETURN IF BELOW LOWER CASE A
	CPI	'z'+1
	RNC			; RETURN IF ABOVE LOWER CASE Z
	ANI 01011111B		; LOWER CASE LETTER, MAKE UPPER
	RET

SIGNON: DB	'PUTSASI version 2.24'
	DW	VERS
	DB	' (c) 1982 Magnolia Microsystems$'

CONMSG: DB	CR,LF,'Put system to Controller 0',BS,ESC,'j$'

LUNMSG: DB	CR,LF,'            Logical Unit 0',BS,ESC,'j$'

BADFIL: DB	'Source File INCOMPLETE$'

BELMSG: DB	ESC,'k',ESC,'K',BEL,'$'

ASKGET: DB	CR,LF,'Did you just execute a "MOVCPM" type program ? Y'
	DB	BS,ESC,'j$'

NOFILE: DB	'File not found$'

NORMSG: DB	'CP/M drive table full$'

GETF:	DB	'Loading System from "'
SNAME:	DB	'd:filename.COM"...$'

	IF	(TPA+512) > $
	  ORG	TPA+512     ; HSTBUF=512
	ENDIF
;
;	END OF CODE WHICH MAY BE OVERLAID AFTER INITIALIZATION. THE
;	FOLLOWING CODE MUST BE LOCATED AFTER THE 512 BYTE SECTOR
;	BUFFER, BUT DOES NOT ACCESS THE DIRECTORY, SO IT CAN BE LOCATED
;	WITHIN THE AREA TO BE LATER OVERLAID BY ALV0.
;
PAGE


CONTIN: CALL	SELCT		; SELECT DEST DRIVE
	LDA	LOADP+3 	; NUMBER OF SECTORS FOR BOOT TO LOAD
	ADI	2		; ADD IN BOOT'S SECTORS
	STA	NEEDED		; TOTAL SECTORS IN SYSTEM
	MOV	C,A
	LDA	OFF		; NUMBER OF SYSTEM TRACKS
	LDED	SPT		; SECTORS PER TRACK
	LXI	H,0
MLT:	DCR	A
	JM	XMLT
	DAD	D
	JR	MLT		; (HL) = OFF * SPT
XMLT:	MOV	A,H
	ORA	A
	JRNZ	SZOK		; OVER 256 SECTORS AVAILABLE
	MOV	A,L
	CMP	C		; COMPARE TO NEEDED SECTORS
	LXI	D,SZERR
	JC	TWOMSG		; NOT ENOUGH SPACE MESSAGE
SZOK:	CALL	GETPUT		; TO PUT SYSTEM ON SASI DISK
	JMP	SYSFIL		; WRITE SYSTEM I/O FILE

;
GETPUT:
;	PUT CP/M - DISK IS ALREADY SELECTED
;
	LXI	H,LOADP 	; LOAD POINT IN RAM FOR CP/M DURING SYSGEN
	CALL	SDMA
	LDA	NEEDED		; SECTORS NEEDED FOR SYSTEM
	PUSH	PSW		; TO COUNT SECTORS AS READ/WRITTEN
	XRA	A
	STA	TRACK
	INR	A
	STA	SECTOR
DOTRK:	LDA	TRACK
	MOV	C,A
	MVI	B,0
	CALL	TRK
HRD$LOOP:
	LDA	SECTOR
	MOV	C,A
	CALL	SEC
	CALL	DWRITE
	ORA	A
	JRNZ	ERR$HRD
	CALL	GDMA
	LXI	H,128
	DAD	D
	MOV	A,H
	CPI	SYSIOA/256
	JRNZ	NOSKIP
	MOV	A,L
	CPI	SYSIOA MOD 256
	JRNZ	NOSKIP
	LXI	D,SYSIOS*128
	DAD	D
NOSKIP:
	CALL	SDMA		; NEW DMA ADDRESS
	POP	PSW
	DCR	A		; WRITE ANOTHER SECTOR ?
	RZ
	PUSH	PSW
	LXI	H,SECTOR
	INR	M		; INCREMENT TO NEXT SECTOR
	LDA	SPT		; SECTORS PER TRACK
	CMP	M		; SEE IF AT END OF TRACK
	JRNC	HRD$LOOP
	MVI	M,1		; START NEW TRACK WITH SECTOR 1
	LXI	H,TRACK
	INR	M		; INCREMENT TO NEXT TRACK
	JR	DOTRK

ERR$HRD:
	LXI	D,BADDISK	
	JMP	MSGBOOT 

	IF	(TPA+512+256) > $
	  ORG	TPA+512+81	; HSTBUF=512 ALV0=256
	ENDIF
;
;	END OF CODE WHICH MAY BE OVERLAID BY ALLOCATION VECTOR. THE FOLLOWING
;	CODE MUST BE LOCATED AFTER THE 512 BYTE SECTOR BUFFER AND THE 256 BYTE
;	ALLOCATION BUFFER.
;

;	WRITE CCP.SYS TO USER 31
;
SYSFIL: MVI	E,255
	MVI	C,QUSER 	; QUERY USER NUMBER
	CALL	BDOS
	STA	USER$NUM	; SAVE CURRENT USER NUMBER
	MVI	E,31		; SET USER NUMBER FOR SYSTEM FILE
	MVI	C,QUSER
	CALL	BDOS
	LXI	D,SYSIO 	; UNCONDITIONALLY DELETE ANY
	MVI	C,DELT		; EXISTING CCP.SYS FILE
	CALL	BDOS
	LXI	D,SYSIO 	; AND CREATE A NEW FILE. THIS IS
	MVI	C,CREAT 	; TO KEEP THE FILE AS CLOSE TO
	CALL	BDOS		; THE DIRECTORY AS POSSIBLE
	INR	A		; 255 => 0
	JRZ	NOSPC		; UNSUCCESSFUL CREATE (MAKE FILE)
	LXI	H,SYSIOA	; ADDRESS OF CCP.SYS IN CORE
	MVI	B,SYSIOS	; NUMBER OF SECTORS (16)
LOOPX:	PUSH	B
	PUSH	H
	CALL	SDMA
	LXI	D,SYSIO
	MVI	C,WRITEF	; WRITE 128 BYTES
	CALL	BDOS
	ORA	A
	JRNZ	NOSPC		; UNSUCCESSFUL WRITE
	POP	H		; RECALL DMA ADDRESS
	LXI	D,128		; CALCULATE NEW DMA ADDRESS
	DAD	D
	POP	B
	DCR	B		; DECREMENT SECTOR COUNTER
	JRNZ	LOOPX		; AND WRITE ANOTHER SECTOR
	LXI	D,SYSIO
	MVI	C,CLOSEF	; CLOSE CCP.SYS FILE
	CALL	BDOS
	INR	A		; 255 => 0
	JRZ	NOSPC		; CANNOT CLOSE FILE
	LDA	USER$NUM	; RESTORE ORIGINAL USER NUMBER
	MOV	E,A
	MVI	C,QUSER
	CALL	BDOS		; AND RETURN
	LXI	D,WDONE
	JMP	MSGBOOT

NOSPC:	LXI	D,SPCMSG
	JR	MSGBOOT

TWOMSG: CALL	OUTMSG
	LXI	D,NOACTN	; FALL THROUGH TO MSGBOOT

;
;	RETURN TO CCP
;
MSGBOOT:CALL	OUTMSG
REBOOT: LHLD	WBOOT
	LXI	D,TBOFF-3
	DAD	D		; POINT TO LOGICAL / PHYSICAL ENTRY
	LDA	OLDLET		; AND RESTORE THE ORIGINAL ENTRY
	MOV	M,A		; IN THE TABLE.
	LHLD	DRVLOC
	XRA	A
	MOV	M,A
	INX	H
	MOV	M,A
	LHLD	SASILOC 	; RE-ENABLE CURRENT SASI DRIVER
	MVI	M,50
SAFEBT: XRA	A		; RETURN WITH THE SELECT OF DRIVE A:
	CALL	SELCT
	CALL	CRLF
	JMP	CPM

MSGSBT: CALL	OUTMSG
	JR	SAFEBT
PAGE


;	SASI BUS DISK DRIVER FUNCTIONS
;
;	SELECT DISK CODE
;
SEL$SASI:
	LDA	INIT$FLAG	; NEED TO INITIALIZE ?
	ORA	A
	CNZ	INIT$SASI
	JRNZ	ERREXT
	LDA	PNDWRT		; CLEAR ANY PENDING WRITE
	ORA	A
	CNZ	WR$SEC
	LDA	MODE1		; FIRST MODE BYTE
	ANI	3		; ISOLATE SECTOR SIZE BITS
	STA	BLCODE		; SAVE AS DEBLOCKING CODE
RETSEL: MVI	C,0
	LXI	D,DPH0
	RET

ERREXT: MVI	A,1
	STA	SELERR
	JR	RETSEL
PAGE


READ$SASI:
	LDA	PNDWRT		; SECTOR WAITING TO BE WRITTEN ?
	ORA	A
	CNZ	WR$SEC
	MVI	A,READOP	; FLAG A READ OPERATION
	JR	RWOPER

WRITE$SASI:
	MOV	A,C

RWOPER: STA	WRTYPE		; SAVE WRITE TYPE
	LDA	SELERR
	ORA	A
	RNZ
	LHLD	NEWDSK
	MOV	A,M
	STA	REQDSK
	LHLD	HRDTRK
	MOV	A,M
	INX	H
	MOV	H,M
	MOV	L,A
	SHLD	REQTRK
	MVI	C,0		; CALCULATE PHYSICAL SECTOR
	LDA	BLCODE		; PHYSICAL SECTOR SIZE CODE
	ORA	A		; TEST FOR ZERO
	MOV	B,A
	LHLD	NEWSEC
	MOV	A,M
	STA	REQSEC		; INITIAL GUESS IS 128 BYTE SECTORS
	JRZ	DBLOK3		; 128 BYTE SECTORS ?
DBLOK1: SRLR	A		; DIVIDE ACCUMULATOR BY 2
	RARR	C		; SAVE OVERFLOW BITS
	DJNZ	DBLOK1		; AND CONTINUE IF BLOCKING STILL <> 0
	STA	REQSEC		; SAVE IT
	LDA	BLCODE		; CALCULATE BLKSEC
	MOV	B,A		; FOR LOOPING
DBLOK2: RLCR	C		; NOE RESTORE THE OVERFLOW BY
	DJNZ	DBLOK2		; ROTATING IT RIGHT
DBLOK3: MOV	A,C
	STA	BLKSEC		; STORE IT
	MVI	A,0FFH
	STA	RD$FLAG 	; FLAG A PRE-READ
	LDA	WRTYPE
	RAR			; CARRY IS SET ON WRDIR AND READOP
	JRC	ALLOC		; NO NEED TO CHECK FOR UNALLOCATED RECORDS
	RAR			; CARRY IS SET ON WRUNA
	JRNC	CHKUNA
	SDED	URECORD 	; SET UNALLOCATED RECORD #
	DCR	A
	STA	UNALLOC 	; FLAG WRITING OF AN UNALLOCATED BLOCK
CHKUNA: LDA	UNALLOC 	; ARE WE WRITING AN UNALLOCATED BLOCK ?
	ORA	A
	JRZ	ALLOC
	LHLD	URECORD 	; IS REQUESTED RECORD SAME AS EXPECTED
	DSBC	D		;  SAME AS EXPECTED UNALLOCATED RECORD ?
	JRNZ	ALLOC		; IF NOT, THEN DONE WITH UNALLOCATED BLOCK
	XRA	A		; CLEAR PRE-READ FLAG
	STA	RD$FLAG
	INX	D		; INCREMENT TO NEXT EXPECTED UNALLOCATED RECORD
	SDED	URECORD
	LDA	BLM
	ANA	E		; IS IT THE START OF A NEW BLOCK ?
	JRNZ	CHKSEC
ALLOC:	XRA	A		; NO LONGER WRITING AN UNALLOCATED BLOCK
	STA	UNALLOC
PAGE


;*****************************************************************************
; CHKSEC: THIS SUBROUTINE COMPARES THE REQUESTED DISK TRACK AND SECTOR	     ;
;	  TO THE DISK,TRACK AND SECTOR CURRENTLY IN THE BUFFER. 	     ;
;	  OUTPUT: ZERO FLAG SET IF SAME, RESET IF DIFFERENT		     ;
;									     ;
CHKSEC: ANA	A		; CLEAR CARRY FOR DSBC			     ;
	LHLD	REQTRK		; REQUESTED TRACK (0,1,2,3 ETC) 	     ;
	LDED	OFF		; GET SYSTEM OFFSET FROM DPB		     ;
	DSBC	D							     ;
	JRNZ	CHKBUF							     ;
	LHLD	NEWSEC							     ;
	MOV	A,M							     ;
	ORA	A		; FIRST SECTOR OF DIRECTORY ?		     ;
	JRZ	READIT							     ;
CHKBUF: LXI	H,REQDSK						     ;
	LXI	D,HSTDSK						     ;
	MVI	B,4							     ;
CHKBUF1:LDAX	D							     ;
	CMP	M							     ;
	JRNZ	READIT							     ;
	INX	H							     ;
	INX	D							     ;
	DJNZ	CHKBUF1 						     ;
	JR	NOREAD		;  THEN NO NEED TO PRE-READ		     ;
;*****************************************************************************
PAGE


READIT: LDA	PNDWRT		; IS THERE A SECTOR THAT NEEDS TO BE WRITTEN ?
	ORA	A
	CNZ	WR$SEC		; WRITE IT
	LXI	D,HSTDSK	; SET UP NEW BUFFER PARAMETERS
	LXI	H,REQDSK
	LXI	B,4
	LDIR
	LDA	RD$FLAG 	; DO WE NEED TO PRE-READ ?
	ORA	A
	CNZ	RD$SEC		; READ THE SECTOR
NOREAD: LXI	H,HSTBUF	; POINT TO START OF SECTOR BUFFER
	LXI	B,128
	LDA	BLKSEC		; POINT TO LOCATION OF CORRECT LOGICAL SECTOR
MOVIT1: DCR	A
	JM	MOVIT2
	DAD	B
	JR	MOVIT1
MOVIT2: CALL	GDMA		; DMA ADDRESS IN D,E
	LDA	WRTYPE		; IS IT A READ OR A WRITE
	CPI	READOP
	JRZ	MOVIT3
	XCHG			; SWITCH DIRECTION OF MOVE FOR WRITE
	MVI	A,1		; FLAG A PENDING WRITE
	STA	PNDWRT
MOVIT3: LDIR			; MOVE IT
	LDA	WRTYPE		; CHECK FOR DIRECTORY WRITE
	DCR	A
	CZ	WR$SEC		; WRITE THE SECTOR IF IT IS
	XRA	A		; FLAG NO ERROR
	RET			; RETURN TO BDOS

WR$SEC: CALL	WRITE		; WRITE A PHYSICAL SECTOR
	MVI	A,0
	STA	PNDWRT		; FLAG NO PENDING WRITE
	RZ			; RETURN IF WRITE WAS SUCCESSFUL
	LDA	WRTYPE
	CPI	READOP		; IGNORE ERROR IF THIS IS A READ OPERATION
	RZ
	JR	RWERR

RD$SEC: CALL	READ		; READ A PHYSICAL SECTOR
	RZ			; RETURN IF SUCCESSFUL
	MVI	A,0FFH		; FLAG BUFFER AS UNKNOWN
	STA	HSTDSK
RWERR:	POP	D		; THROW AWAY TOP OF STACK
	MVI	A,1		; SIGNAL ERROR TO BDOS
	ORA	A
	RET			; RETURN TO BDOS
PAGE


;	READ A PHYSICAL SECTOR CODE
;
READ:
	MVI	A,RDBL		; READ COMMAND CODE
	JR	DO$RW		; COMMON READ-WRITE ROUTINE
;
;	WRITE A PHYSICAL SECTOR CODE
;
WRITE:
	MVI	A,WRBL		; WRITE COMMAND CODE
;
;	COMMON READ-WRITE CODE
;
DO$RW:	STA	CMCDE		; COMMAND BUFFER OP CODE
	CALL	CAL$SEC 	; CALCULATE AND INSTALL ACTUAL SECTOR
	CALL	WAKE$UP 	; SETUP CONTROLLER
	CZ	OUTCOM		; AND OUTPUT THE COMMAND
	CZ	SASIRW		; DO READ OR WRITE
	CZ	CHK$STAT	; CHECK THE BUS RESPONSE
	RET

RESET:	LDA	BASE$PORT
	INR	A
	MOV	C,A		; CONTROL PORT TO REG. C
	MVI	A,RUN
	OUTP	A
	MVI	A,SWRS
	OUTP	A		; RESET CONTROLLER
	LDA	INIT$FLAG	; HAS DRIVE BEEN INITIALIZED ?
	ORA	A		;  DONE IF IT HASN'T
	RNZ
	LDA	DRVDATA 	; CHECK FOR XEBEC DRIVE
	ANI	11100000B
	JRNZ	NOTXBC
	MVI	A,INIT		; INITIALIZE DRIVE CHARACTERISTICS COMMAND
	STA	CMBFR
	CALL	GETCON		; GET CONTROLLER'S ATTENTION
	RNZ			; THIS WOULD BE SECOND ERROR ON GETCON
	CALL	OUTCOM		; OUTPUT COMMAND
	RNZ
	LXI	H,DRVDATA+2	; DRIVE CHARACTERISTIC DATA
	MVI	B,8		; 8 BYTES LONG
	MVI	E,(REQ OR POUT OR BUSY)
	CALL	OUTCM1		; OUTPUT THE DATA
	CZ	CHK$STAT	;  AND CHECK STATUS
	RNZ
NOTXBC: LXI	H,DRVDATA+10	; OP CODE FOR "ASSIGN DRIVE TYPE" COMMAND
	LXI	D,CMBFR
	LXI	B,6
	LDIR
	CALL	GETCON		; GET CONTROLLER'S ATTENTION
	CZ	OUTCOM		; SEND THE COMMAND
	CZ	CHK$STAT
	LDA	DRVDATA+1
	STA	CMBFR+5 	; PUT CONTROL BYTE BACK
	RET

PAGE


CAL$SEC:
	LHLD	HSTTRK		; GET REQUESTED TRACK
	DAD	H		; *2
	DAD	H		; *4
	DAD	H		; *8
	DAD	H		; *16
	DAD	H		; *32
	DAD	H		; *64 (64 SECTORS/TRACK)
	PUSH	H
	LXI	H,SECPTR
	MOV	C,M
	INX	H
	MOV	D,M
	INX	H
	MOV	E,M
	POP	H
	DAD	D		; ADD IN PARTITION OFFSET
	JRNC	NOCARY		; CARRY FROM DAD (IF ANY) GOES INTO
	INR	C		;  HIGH ORDER BYTE OF SECTOR NUMBER
NOCARY: LDA	BLCODE
	MOV	B,A
	ORA	A
	JZ	NODIV
NXDIV:	SRAR	C
	RARR	H
	RARR	L
	DJNZ	NXDIV
	LDA	HSTSEC		; GET REQUESTED SECTOR
	MOV	E,A
	MVI	D,0
	DAD	D		; ADD IT IN
NODIV:	LDA	LUN
	ORA	C		; OR L.U.N. BITS BACK IN
	STA	CMBFR+1 	; MOVE TO COMMAND BUFFER
	MOV	A,H
	STA	CMBFR+2 	; MOVE REST OF SECTOR NUMBER TO COMMAND BUFFER
	MOV	A,L
	STA	CMBFR+3
	MVI	A,1		; TRANSFER 1 SECTOR
	STA	CMBFR+4
	LDA	DRVDATA+1	; GET CONTROL BYTE
	STA	CMBFR+5
	RET

PAGE


WAKE$UP:LDA	CMCDE
	STA	CMBFR
	CALL	GETCON
	RZ
	CALL	RESET
	RNZ
	LDA	CMCDE
	STA	CMBFR
	CALL	GETCON
	RET
;
;	GET THE BUS' ATTENTION
;
GETCON: LDA	BASE$PORT
	MOV	C,A
	INR	C		; CONTROL PORT TO REG. C
	MVI	B,0		; TIMER COUNTER
GETCN1: DCR	C		; DATA PORT
	XRA	A
	OUTP	A		; CLEAR DATA REGISTER
	LDA	CNUM		; GET CONTROLLER NUMBER
	INR	C
	INR	C		; -SENC- PORT
	OUTP	A
	DCR	C		; CONTROL PORT
	INP	A		; READ CONTROL PORT
	ANI	BUSY
	JRZ	GETCN2
	DJNZ	GETCN1
	DCR	B		; RESET PSW/Z TO INDICATE ERROR
	RET
GETCN2: 
	MVI	A,SEL
	OUTP	A		; WAKE UP CONTROLER
	MVI	B,0
GETCN3: INP	A
	ANI	BUSY
	JRNZ	GETCN4
	DJNZ	GETCN3
	DCR	B		; RESET PSW/Z TO INDICATE ERROR
	RET
GETCN4: 
	MVI	A,RUN
	OUTP	A
	XRA	A		; NO ERROR
	RET

PAGE


;	OUTPUT THE COMMAND
;
OUTCOM: 			; OUTPUT A COMMAND TO THE DRIVE
	LXI	H,CMBFR
	MVI	B,6		; COMMAND IS 6 BYTES LONG
	LDA	BASE$PORT
	MOV	C,A		; AND THE OUTPUT PORT NUMBER
	INR	A
	MOV	D,A		; STORE CONTROL PORT ADDRESS IN REG. D
	MVI	E,(REQ OR CMND OR POUT OR BUSY)
OUTCM1: PUSH	B
	MVI	B,16		; SET LOOP COUNTER
	MOV	C,D		; CONTROL PORT ADDRESS TO REG. C
OUTLOP: INP	A
	ANI	(REQ OR CMND OR POUT OR BUSY)
	CMP	E
	JRZ	OUTOK
	DJNZ	OUTLOP
	DCR	B
	POP	B
	RET
OUTOK:	POP	B		; RETURNS DATA PORT ADDRESS TO REG. C
	OUTI			; OUTPUT COMMAND BYTE
	JNZ	OUTCM1
	XRA	A
	RET
PAGE


;	ACTUAL READ-WRITE OF DATA
;
SASIRW: 			; THIS ROUTINE IS FOR READING AND WRITING
	LDA	CMBFR
	SUI	RDBL		; IS COMMAND A READ ?
	MVI	A,0B2H		; INIR FOR READS
	JRZ	NREAD
	MVI	A,0B3H		; OUTIR FOR WRITES
NREAD:	STA	HERE+1
	LXI	H,HSTBUF	; AND WRITING DATA
	LDA	BASE$PORT
	MOV	C,A		; DATA PORT ADDRESS TO REG. C
MORE:	INR	C		; INCREMENT TO CONTROL PORT
SASICK: INP	A		; FIRST CHECK FOR DRIVE READY
	ANI	(CMND OR BUSY OR REQ OR POUT)
	CPI	(CMND OR BUSY OR REQ)  ; IF POUT DROPS,
	RZ			       ;  WE ARE INTO STATUS PHASE
	ANI	(CMND OR BUSY OR REQ)
	CPI	(BUSY OR REQ)	; WHEN CMND DROPS, SEEK IS COMPLETE, AND WE ARE
	JRNZ	SASICK		;  READY FOR DATA TRANSFER
	DCR	C		; DATA PORT ADDRESS TO REG. C
	MVI	B,128
HERE:	INIR			; CHANGED TO OUTIR FOR WRITE
	JR	MORE

PAGE



;	CHECK STATUS OF READ OR WRITE
;
CHK$STAT:			; THIS ROUTINE CHECKS WHAT'S UP
	LXI	H,STAT		; STATUS BUFFER
	LDA	BASE$PORT
	MOV	D,A		; DATA PORT ADDRESS STORED IN REG. D
	INR	A
	MOV	E,A		; CONTROL PORT ADDRESS STORED IN REG. E
	JR	CHK01
CHKNXT: MOV	C,D		; INPUT FROM DATA PORT
	INP	A
	MOV	M,A		; SAVE IN MEMORY
CHK01:	MOV	C,E		; INPUT FROM CONTROL PORT
	INP	A
	ANI	(MSG OR REQ OR CMND OR POUT)
	CPI	(REQ OR CMND)
	JRZ	CHKNXT
	CPI	(MSG OR REQ OR CMND)
	JRNZ	CHK01
	MOV	C,D		; INPUT FROM DATA PORT
	INP	A		; GET FINAL BYTE
	MOV	A,M		; AND THROW IT AWAY, GET STATUS
	ANI	03		; EITHER BIT SET IS AN ERROR
	RET
PAGE

;	INITIALIZATION ONLY CODE (IT USES THE BUFFER SPACE)
;
CHK$INIT:
	CALL	WAKE$UP 	; WAKE UP CONTROLLER
	CZ	OUTCOM		; OUTPUT READ COMMAND
	CZ	SASIRW		; READ IN SECTOR
	CZ	CHK$STAT	; CHECK STATUS OF READ
	RNZ
	LXI	H,HSTBUF+DDPB	; GET DPB FROM MAGIC SECTOR
	LXI	D,DPB0		; MOVE IT INTO DPB TABLE IN DRIVER
	LXI	B,21
	LDIR
	LXI	H,HSTBUF+DCTYPE ; GET DRIVE CHARACTERISTIC DATA FROM
	LXI	D,DRVDATA	;  'MAGIC SECTOR'
	LXI	B,16
	LDIR
	LXI	H,HSTBUF+SECTBL ; GET SECTOR ADDRESS FROM MAGIC SECTOR
	LXI	D,SECPTR	; POINT TO ENTRY IN DRIVE DEFINITION TABLE
	LXI	B,3		; INSTALL SECTOR NUMBER 
	LDIR
	XRA	A
	STA	INIT$FLAG
	CALL	RESET
	RET
PAGE


;	UTILITY SUBROUTINES
;
;
;	GET/SET DMA ADDRESS
;
GDMA:	PUSH	H		; RETURN DMA ADDRESS IN DE
	LHLD	DMAA
	MOV	E,M
	INX	H
	MOV	D,M
	POP	H
	RET

SDMA:	XCHG			; SET DMA ADDRESS PASSED IN HL
	MVI	C,SETDMA
	JMP	BDOS
;
;	SEND A CARRIAGE RETURN/LINE FEED TO CONSOLE
;
CRLF:	LXI	D,CRLFMS	; SEND CARRIAGE RETURN, LINE FEED
	JR	MESSA1
;
;	PRINT A MESSAGE ON THE CONSOLE
;
OUTMSG: PUSH	D
	CALL	CRLF
	POP	D
MESSA1: MVI	C,PRINT
	JMP	BDOS		; BDOS PRINT TEXT FUNCTION
PAGE


;	SELECT DISK
;
SELCT:	MOV	C,A		; SELECT DISK GIVEN BY REGISTER A
	LHLD	WBOOT
	LXI	D,SELDSK
	DAD	D
	PCHL
;
;	SET REQUIRED TRACK OR SECTOR
;
TRK:	LHLD	WBOOT		; ADDRESS OF BOOT ENTRY
	LXI	D,SETTRK	; OFFSET FOR SETTRK ENTRY
	DAD	D
	PCHL			; GONE TO SETTRK

SEC:	LHLD	WBOOT		; SET SECTOR
	LXI	D,SETSEC
	DAD	D
	PCHL
;
;	DISK READ AND WRITE FUNCTIONS
;
DWRITE: LHLD	WBOOT
	LXI	D,WRITF
	DAD	D
	MVI	C,WRUNA 	; WRITING TO UNALLOCATED SECTORS
	PCHL
PAGE

;
; VARIABLES
;
NOACTN: DB	'Aborted -- No action taken$'

;----------------------------------------------------------------
;	THIS CODE MUST OCCUR ON A PAGE BOUNDRY			;
;								;
	REPT	(($+0FFH) AND 0FF00H)-$
	  DB	0						;
	ENDM
;								;
DRIVER: JMP	SEL$SASI					;
	JMP	READ$SASI					;
	JMP	WRITE$SASI					;
;----------------------------------------------------------------
;	TEXT STORAGE
;
BADDISK DB	'Disk Write Error$'

WDONE:	DB	'System Installed$'

SZERR:	DB	'New system is too large$'

SPCMSG	DB	'No Space for CCP file$'

CRLFMS: DB	CR,LF,'$'

;		drive O: is 15
SYSIO:	DB	15,'CCP     SYS',0,0,0,0,0,0
	DB	0,0,0,0,0,0,0,0,0,0,0,0,0,0
PAGE


;		VARIABLES
;
USER$NUM  DB	0
TRACK:	  DB	0		; CURRENT TRACK
SECTOR:   DB	0		; CURRENT SECTOR
NEEDED	  DB	0

NEWDSK	  DW	0		; WILL CONTAIN THE ADDRESSES OF
NEWSEC	  DW	0		; THE PARTICULAR DATA LOCATIONS IN
HRDTRK	  DW	0		; THE SYSTEM
DMAA	  DW	0
DRVLOC:   DW	0		; DRIVE BASE TABLE ENTRY ADDRESS
CNUM:	DB	0
LUN	DB	0
CMCDE:	DB	0
STAT:	DB	0
PNDWRT	DB	0		; PENDING WRITE FLAG
RD$FLAG:DB	0		; FLAG FOR PRE-READ
HSTDSK	DB	0FFH
HSTTRK	DW	0
HSTSEC	DB	0
REQDSK	DB	0
REQTRK	DW	0
REQSEC	DB	0
BLCODE: DB	0		; SECTOR SIZE CODE (0=128,1=256,2=512,3=1024)
BLKSEC: DB	0		; LOCATION OF LOGICAL SECTOR WITHIN PHYSICAL
WRTYPE	DB	0
UNALLOC DB	0
URECORD DW	0
SELERR	DB	0		; SELECT ERROR FLAG
BASE$PORT:
	DB	0		; BASE PORT ADDRESS
INIT$FLAG:
	DB	1		; INITIALIZATION FLAG
OLDLET: DB	0		; DRIVE NUMBER OVERLAID IN LOG/PHY TABLE
SASILOC:DW	SASILOC
PAGE

;	DATA BUFFERS AND STORAGE
;
CMBFR:	DB	0,0,0,0,0,0	; COMMAND BUFFER
DRVDATA DB	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

DPH0:	DW	0,0,0,0
DIRBUF: DW	80H,DPB0,CSV0,ALV0	  ; 80H = ADDRESS OF DIRBUF

;	SECTOR DEFINITION/TRANSLATION TABLE
;		--ADDRESS--
SECPTR: DB	0,   0,   0

DPB0:
SPT:	DW	64		; SPT
	DB	5		; BSH
BLM:	DB	31,1		; BLM,EXM
	DW	648-1,512-1	; DSM,DRM
	DB	0F0H,0		; AL0,AL1
	DW	0		; CKS
OFF:	DW	2		; SYSTEM OFFSET
MODE1:	DB	2	  ; MODE BYTES

	DS	32
STACK:	DS	0

	END

